
_readSensor:

;Stretch.mpas,27 :: 		begin
;Stretch.mpas,28 :: 		adc_rd := ADC_Get_Sample(7);               // Read PA7
	PUSH       R2
	LDI        R27, 7
	MOV        R2, R27
	CALL       _ADC_Get_Sample+0
	STS        _adc_rd+0, R16
	STS        _adc_rd+1, R17
;Stretch.mpas,29 :: 		delay_ms(10);                              // Pause 10ms
	LDI        R17, 104
	LDI        R16, 229
L__readSensor1:
	DEC        R16
	BRNE       L__readSensor1
	DEC        R17
	BRNE       L__readSensor1
;Stretch.mpas,30 :: 		end;
L_end_readSensor:
	POP        R2
	RET
; end of _readSensor

_set_adc:

;Stretch.mpas,37 :: 		begin
;Stretch.mpas,38 :: 		DDA7_bit := 0;                              // Set PA7 as input
	IN         R27, DDA7_bit+0
	CBR        R27, BitMask(DDA7_bit+0)
	OUT        DDA7_bit+0, R27
;Stretch.mpas,39 :: 		end;
L_end_set_adc:
	RET
; end of _set_adc

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 14
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;Stretch.mpas,41 :: 		begin
;Stretch.mpas,42 :: 		set_adc();                                 // Set A/D register
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	CALL       _set_adc+0
;Stretch.mpas,43 :: 		LCD_Init();                                // Initialize Lcd
	CALL       _Lcd_Init+0
;Stretch.mpas,44 :: 		Lcd_Cmd(_LCD_CLEAR);                       // Clear display
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;Stretch.mpas,45 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);                  // Cursor off
	LDI        R27, 12
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;Stretch.mpas,46 :: 		Lcd_Out(1,1,'Stretch click');              // Write text in first row
	MOVW       R30, R28
	LDI        R27, 83
	ST         Z+, R27
	LDI        R27, 116
	ST         Z+, R27
	LDI        R27, 114
	ST         Z+, R27
	LDI        R27, 101
	ST         Z+, R27
	LDI        R27, 116
	ST         Z+, R27
	LDI        R27, 99
	ST         Z+, R27
	LDI        R27, 104
	ST         Z+, R27
	LDI        R27, 32
	ST         Z+, R27
	LDI        R27, 99
	ST         Z+, R27
	LDI        R27, 108
	ST         Z+, R27
	LDI        R27, 105
	ST         Z+, R27
	LDI        R27, 99
	ST         Z+, R27
	LDI        R27, 107
	ST         Z+, R27
	LDI        R27, 0
	ST         Z+, R27
	MOVW       R16, R28
	MOVW       R4, R16
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Stretch.mpas,48 :: 		ADC_Init();                                // Initialize ADC
	CALL       _ADC_Init+0
;Stretch.mpas,49 :: 		delay_ms(100);                             // Pause of 100ms for ADC module stabilization
	LDI        R18, 5
	LDI        R17, 15
	LDI        R16, 242
L__main5:
	DEC        R16
	BRNE       L__main5
	DEC        R17
	BRNE       L__main5
	DEC        R18
	BRNE       L__main5
;Stretch.mpas,51 :: 		while TRUE do
L__main8:
;Stretch.mpas,53 :: 		readSensor();                          // Read sensor
	CALL       _readSensor+0
;Stretch.mpas,54 :: 		WordToStr(adc_rd,txt);                 // Conversion int adc_rd to string txt
	LDI        R27, #lo_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R5, R27
	LDS        R2, _adc_rd+0
	LDS        R3, _adc_rd+1
	CALL       _WordToStr+0
;Stretch.mpas,55 :: 		LCD_Out(2,4,txt);                      // Print txt value on LCD
	LDI        R27, #lo_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R5, R27
	LDI        R27, 4
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;Stretch.mpas,56 :: 		delay_ms(500);                         // Pause 500ms
	LDI        R18, 21
	LDI        R17, 75
	LDI        R16, 191
L__main12:
	DEC        R16
	BRNE       L__main12
	DEC        R17
	BRNE       L__main12
	DEC        R18
	BRNE       L__main12
	NOP
;Stretch.mpas,57 :: 		end;
	JMP        L__main8
;Stretch.mpas,59 :: 		end.
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
